hdu-1969-Pie(二分+贪心)

Problem Description

My birthday is coming up and traditionally I’m serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

Input

One line with a positive integer: the number of test cases. Then for each test case:
—One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
—One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.

Output

For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).

Sample Input

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

Sample Output

25.1327
3.1416
50.2655


题意:把n个pie分成f+1块,每个人一块,问每个人能得到的pie的最大体积

代码:

#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#define N 10010
#define ll long long
#define pi acos(-1.0)
#define eps 1e-7
using namespace std;
double a[N];
int n, f;
int main()
{
#ifndef ONLINE_JUDGE
    freopen("1.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int i, j, T, t;
    double sum, high, ans, low;
    cin >> T;
    while(T--) 
    {
        high = 0;
        cin >> n >> f;
        f++;
        for(i = 0; i < n; i++)
        {
            cin >> a[i];
            a[i] = a[i]*a[i]*pi;
            high = max(high, a[i]);
        }
        low = 0;
        while(high - low >= eps)
        {
            ans = (high+low)/2.0;
            for (i = t = 0; i < n; i++) t += (int)(a[i]/ans);
            if (t >= f)
                low = ans;
            else
                high = ans;
        }
        cout.setf(ios::fixed);
        cout << setprecision(4) << ans << endl;
    }
    return 0;
}

你可能感兴趣的:(杭电)